//
//  SynthEG.h
//
//  Created by 成田 拓郎 on 10/05/01.
//  Copyright 2010 lovelyshark. All rights reserved.
//

#import "SynthObject.h"
//#import <Foundation/Foundation.h>

//EGモード
enum {
	EG_ATTACK_MODE,
	EG_DECAY_MODE,
	EG_SUSTAIN_MODE,
	EG_RELEASE_MODE,
	EG_SPACE_MODE
};

@interface SynthEG : SynthObject {
	//EGのモード(0:Attack 1:Decay 2:Sustain 3:Release)
	int   outputMode;
	//EGの直前出力レベル
	float outputLevel;
	//EGのAttack(秒)
	float paramAttack;
	//EGのDecay(秒)
	float paramDecay;
	//EGのSustainレベル(0～1)
	float paramSustain;
	//EGのRelease(秒)	
	float paramRelease;
	//Attackからの経過カウンタ
	float attackCount;
}

@property int outputMode;
@property (readonly) float outputLevel;
@property float paramAttack;
@property float paramDecay;
@property float paramSustain;
@property float paramRelease;

@property (readonly) float score;	//EGの進行具合のスコア

@end
