//
//  SynthObject.h
//
//  Created by 成田 拓郎 on 10/04/30.
//  Copyright 2010 lovelyshark. All rights reserved.
//

#import <Foundation/Foundation.h>

#define SAMPLE_RATE		44100
#define WAVEOUT_BASE	2
#define WAVEOUT_SIZE	(WAVEOUT_BASE + SAMPLE_RATE)

@interface SynthObject : NSObject {
	BOOL flag; //NO:未計算 YES:計算済み

	//入力
	SynthObject *inputWaveObject;
	SynthObject *inputControlObject;
	float controlLevel; //inputControlObjectの入力レベル

	//出力
	float buffer[WAVEOUT_SIZE];
	float *outputBuffer;
	int bufferLength; //計算済みデータ長
}

//加法性ホワイト ガウス ノイズ(AWGN:additive white Gaussian noise)
+ (float) AWGN;
//ダミーバッファ
+ (float*) dummyBuffer0;	//全体が0.0のバッファ
+ (float*) dummyBuffer1;	//全体が1.0のバッファ
//出力サンプルレート(全体で値を共有する。引数が負の値の場合、値を更新しない)
+ (float) outputSampleRate:(float)rate;

//演算開始処理
- (void) synthBeing;
//入力オブジェクトの初期化
//(入力オブジェクトを追加した場合、派生クラスでオーバーライドして、
// 入力オブジェクトのsynthBeginを呼び出す)
- (void) synthBeingInput;
//このオブジェクトの演算関数(派生クラスでオーバーライド)
- (void) synthFunc:(int)length;
//演算チェーンの実行
- (void) synth:(int)length;
//演算チェーンの実行(追加した入力オブジェクト)
//(入力オブジェクトを追加した場合、派生クラスでオーバーライドして、
// 入力オブジェクトのsynth:を呼び出す)
- (void)synthInput:(int)length;

@property (retain) SynthObject *inputWaveObject;
@property (retain) SynthObject *inputControlObject;
@property float controlLevel;
@property (readonly) float *outputBuffer;

@end
