//
//  SynthVCO.h
//
//  Created by 成田 拓郎 on 10/04/30.
//  Copyright 2010 lovelyshark. All rights reserved.
//

#import "SynthObject.h"
//#import <Foundation/Foundation.h>

#define VCO_LFO 0.1f  //LFOでVCO周波数を最大10%変調する

//VCOタイプ
enum {
	VCO_SAW_TOOTH_WAVE,	//ノコギリ波
	VCO_SQUARE_WAVE,	//矩形波
	VCO_TRIANGLE_WAVE,	//三角波
	VCO_PULSE_WAVE,		//パルス波
	VCO_SIN_WAVE,		//サイン波
	VCO_WHITE_NOISE		//ホワイトノイズ
};

@interface SynthVCO : SynthObject {
	//VCOタイプ
	int waveType;
	//パルス幅(パルス波の場合)
	float pulseWidth;
	//周波数
	float frequency;
	//現在の位相
	float phase;
}

+ (float*) waveSawTooth;	//ノコギリ波
+ (float*) waveSquare;		//矩形波
+ (float*) waveTriangle;	//三角波
- (float*) wavePulse;		//パルス波
+ (float*) waveSin;			//サイン派
+ (float*) waveWhiteNoise;	//ホワイトノイズ
- (float*) waveBase;		//選択波形

+ (float) note2Frequency:(float)note_number;	//ノート番号→周波数

@property int waveType;
@property float pulseWidth;
@property float frequency;
@property (readonly) float phase;

@end
